#property  copyright "Adeo" 
#property  link      "adeomercatus@yahoo.com"


#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     DeepSkyBlue
#property indicator_color2     PaleVioletRed
#property indicator_color3     PaleVioletRed
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_levelcolor DimGray
#property indicator_level1     0.0

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    ShowValue        =  1;
extern int    Type             =  0;
extern double emaPeriod        = 12;
extern int    PALAreaBars      =  3;
extern double SmoothLength     =  3;
extern double SmoothPhase      =  0;
extern bool   SmoothDouble     = false;
extern int    ChangeColorType  = 0;
extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "pal arrows";
extern color  arrowsUpColor    = DeepSkyBlue;
extern color  arrowsDnColor    = PaleVioletRed;
extern bool   Interpolate      = true;

//
//
//
//
//

double value[];
double valueDa[];
double valueDb[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   ShowValue = MathMax(MathMin(ShowValue,9),0);
   emaPeriod = MathMax(emaPeriod,1);
      string name = "";
      switch (ShowValue)
      {   
         case 0 : name = "PAL Line";         break;
         case 1 : name = "PAL Average Line"; break;
         case 2 : name = "PAL Momentum";     break;
         case 3 : name = "PAL Area";         break;
         case 4 : name = "PAL Span";         break;
         case 5 : name = "PAL Average Span"; break;
         case 6 : name = "PAL TOW";          break;
         case 7 : name = "PAL Average TOW";  break;
         case 8 : name = "PAL Dir";          break;
         case 9 : name = "PAL Average Dir";  break;
      }         

      IndicatorBuffers(4);
      SetIndexBuffer(0,value);   SetIndexLabel(0,name);
      SetIndexBuffer(1,valueDa); SetIndexLabel(1,name);
      SetIndexBuffer(2,valueDb); SetIndexLabel(2,name);
      SetIndexBuffer(3,trend);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" "+name+" ("+ShowValue+", "+Type+", "+DoubleToStr(emaPeriod,2)+", "+PALAreaBars+")");
   return(0);
}
int deinit()
{
   if (!calculateValue && ShowArrows) deleteArrows();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][10];
#define PALLine      0
#define PALaLine     1
#define PALMomentum  2
#define PALArea      3 
#define PALSpan      4 
#define PALaSpan     5
#define PALTOW       6
#define PALaTOW      7
#define PALDir       8
#define PALaDir      9

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars = IndicatorCounted();
      
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { value[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
    
   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
      if (trend[limit]==-1) CleanPoint(limit,valueDa,valueDb);
            
      //
      //
      //
      //
      //
            
      double emaFactor = 2.0/(1.0+emaPeriod);
      double point     = Point; if (Digits==3 || Digits==5) point *= 10;
      for (i=limit, r=Bars-i-1; i >= 0; i--, r++)
      {
         if (Type==0)
         {
            double H  = iHigh(NULL,0,i);
            double PH = iHigh(NULL,0,i+1);
            double L  = iLow(NULL,0,i);
            double PL = iLow(NULL,0,i+1);
         }
         else
         {
                   H  = iClose(NULL,0,i);
                   PH = iClose(NULL,0,i+1);
                   L  = iOpen(NULL,0,i);
                   PL = iOpen(NULL,0,i+1);
         }   

         //
         //
         //
         //
         //
            
         work[r][PALLine]     = (H + L - PH - PL) / point;
         work[r][PALSpan]     = (PH - PL) / point;
         work[r][PALaLine]    = (emaFactor*(work[r][PALLine]))+((1-emaFactor)*work[r-1][PALaLine]);          
         work[r][PALaSpan]    = (emaFactor*(work[r][PALSpan]))+((1-emaFactor)*work[r-1][PALaSpan]); 
         work[r][PALArea]     = 0;
               for (int j = 0; j<PALAreaBars; j++) work[r][PALArea] += work[r-j][PALLine];
   //      work[r][PALMomentum] = work[r][PALaLine] * work[r][PALSpan] * iVolume(NULL,0,i);         
         work[r][PALMomentum] = work[r][PALArea] * work[r][PALaSpan];         

         int PALSign =-1.0;
                  if (MathAbs(H-PL) >= MathAbs(L-PH)) PALSign=1;
                  if (PALSign==1.0)
                        if (L-PH!=0.0)
                             work[r][PALTOW] =  PALSign*(MathAbs(H-PL)/MathAbs(L-PH))/point/100.0;
                        else work[r][PALTOW] =  work[r-1][PALTOW];
                  else
                        if (H-PL!=0.0)
                             work[r][PALTOW] =  PALSign*(MathAbs(L-PH)/MathAbs(H-PL))/point/100.0;
                        else work[r][PALTOW] =  work[r-1][PALTOW];
   
         work[r][PALTOW]  = MathMin(MathMax(work[r][PALTOW],-1000.0),1000.0);
         work[r][PALaTOW] = (emaFactor*(work[r][PALTOW]))+((1-emaFactor)*work[r-1][PALaTOW]);          
      
         if (MathAbs(H-PL) >= MathAbs(L-PH))
              work[r][PALDir] = (H-PL)/point;
         else work[r][PALDir] = (L-PH)/point;
              work[r][PALaDir] = (emaFactor*(work[r][PALDir]))+((1-emaFactor)*work[r-1][PALaDir]);          
      

         //
         //
         //
         //
         //
      
         switch (ShowValue)
         {   
            case 0 : value[i] = iDSmooth(SmoothDouble,work[r][PALLine]    ,SmoothLength,SmoothPhase,i); break;
            case 1 : value[i] = iDSmooth(SmoothDouble,work[r][PALaLine]   ,SmoothLength,SmoothPhase,i); break;
            case 2 : value[i] = iDSmooth(SmoothDouble,work[r][PALMomentum],SmoothLength,SmoothPhase,i); break;
            case 3 : value[i] = iDSmooth(SmoothDouble,work[r][PALArea]    ,SmoothLength,SmoothPhase,i); break;
            case 4 : value[i] = iDSmooth(SmoothDouble,work[r][PALSpan]    ,SmoothLength,SmoothPhase,i); break;
            case 5 : value[i] = iDSmooth(SmoothDouble,work[r][PALaSpan]   ,SmoothLength,SmoothPhase,i); break;
            case 6 : value[i] = iDSmooth(SmoothDouble,work[r][PALTOW]     ,SmoothLength,SmoothPhase,i); break;
            case 7 : value[i] = iDSmooth(SmoothDouble,work[r][PALaTOW]    ,SmoothLength,SmoothPhase,i); break;
            case 8 : value[i] = iDSmooth(SmoothDouble,work[r][PALDir]     ,SmoothLength,SmoothPhase,i); break;
            case 9 : value[i] = iDSmooth(SmoothDouble,work[r][PALaDir]    ,SmoothLength,SmoothPhase,i);
         }

         valueDa[i] = EMPTY_VALUE;         
         valueDb[i] = EMPTY_VALUE;         
         trend[i]   = 0;
            switch(ChangeColorType)
            {
               case 1:  trend[i] = trend[i+1]; 
                           if (value[i]>value[i+1]) trend[i] = 1;
                           if (value[i]<value[i+1]) trend[i] =-1;
                        break;
               case 2:  trend[i] = trend[i+1]; 
                           if (value[i]>0) trend[i] = 1;
                           if (value[i]<0) trend[i] =-1;
                        break;
               default: break;
            }
            if (!calculateValue) if (trend[i]==-1) PlotPoint(i,valueDa,valueDb,value);
            if (!calculateValue) manageArrow(i);
      }
      return(0);
   }
 
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowValue,Type,emaPeriod,PALAreaBars,SmoothLength,SmoothPhase,SmoothDouble,ChangeColorType,3,y);
         value[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowValue,Type,emaPeriod,PALAreaBars,SmoothLength,SmoothPhase,SmoothDouble,ChangeColorType,0,y);
         valueDa[i] = EMPTY_VALUE;         
         valueDb[i] = EMPTY_VALUE;         
            manageArrow(i);

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
                  value[i+k] = value[i] + (value[i+n] - value[i])*k/n;
   }
   for (i=limit; i >= 0; i--) if (trend[i]==-1) PlotPoint(i,valueDa,valueDb,value);
   
   //
   //
   //
   //
   //

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
         deleteArrow(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i] == 1) drawArrow(i,arrowsUpColor,233,false);
            if (trend[i] ==-1) drawArrow(i,arrowsDnColor,234,true);
         }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(bool isDouble, double price, double length, double phase, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (        iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}